/* tslint:disable */
/* eslint-disable */
/**
 * Viral Loops v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface CompleteFriend
 */
export interface CompleteFriend {
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof CompleteFriend
     */
    'attributes'?: { [key: string]: string; };
    /**
     * required if no friend_contact_id
     * @type {string}
     * @memberof CompleteFriend
     */
    'friend_id': string;
    /**
     * required if no friend_id
     * @type {string}
     * @memberof CompleteFriend
     */
    'friend_contact_id': string;
}
/**
 * Finished viral loop milestone for specific referral
 * @export
 * @interface CompletedMilestone
 */
export interface CompletedMilestone {
    /**
     * 
     * @type {string}
     * @memberof CompletedMilestone
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof CompletedMilestone
     */
    'referral_id': string;
    /**
     * 
     * @type {string}
     * @memberof CompletedMilestone
     */
    'milestone_id': string;
    /**
     * 
     * @type {string}
     * @memberof CompletedMilestone
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof CompletedMilestone
     */
    'updated_at': string;
}
/**
 * 
 * @export
 * @interface EmailNotification
 */
export interface EmailNotification {
    /**
     * 
     * @type {string}
     * @memberof EmailNotification
     */
    'subject': string;
    /**
     * 
     * @type {string}
     * @memberof EmailNotification
     */
    'body': string;
    /**
     * 
     * @type {string}
     * @memberof EmailNotification
     */
    'footer': string;
}
/**
 * User invited via referral link
 * @export
 * @interface Friend
 */
export interface Friend {
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'viral_loop_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'referral_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'contact_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'channel_id': string;
    /**
     * 
     * @type {Array<Reward>}
     * @memberof Friend
     */
    'rewards'?: Array<Reward>;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'status': FriendStatusEnum;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'updated_at': string;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof Friend
     */
    'attributes'?: { [key: string]: string; };
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'name': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'gateway_messenger_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'email'?: string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'referral_activity_id': string;
    /**
     * 
     * @type {string}
     * @memberof Friend
     */
    'messenger_id': string;
}

export const FriendStatusEnum = {
    Created: 'created',
    Completed: 'completed'
} as const;

export type FriendStatusEnum = typeof FriendStatusEnum[keyof typeof FriendStatusEnum];

/**
 * 
 * @export
 * @interface ListViralLoops200Response
 */
export interface ListViralLoops200Response {
    /**
     * 
     * @type {Array<ViralLoop>}
     * @memberof ListViralLoops200Response
     */
    'results'?: Array<ViralLoop>;
    /**
     * 
     * @type {number}
     * @memberof ListViralLoops200Response
     */
    'total'?: number;
}
/**
 * Viral loop milestone specifies the finish conditions and optional rewards for both referral and friend
 * @export
 * @interface Milestone
 */
export interface Milestone {
    /**
     * 
     * @type {string}
     * @memberof Milestone
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof Milestone
     */
    'viral_loop_id': string;
    /**
     * 
     * @type {string}
     * @memberof Milestone
     */
    'name': string;
    /**
     * 
     * @type {number}
     * @memberof Milestone
     */
    'complete_threshold': number;
    /**
     * 
     * @type {RewardConfig}
     * @memberof Milestone
     */
    'referral_reward_each'?: RewardConfig;
    /**
     * 
     * @type {RewardConfig}
     * @memberof Milestone
     */
    'referral_reward_milestone_completed'?: RewardConfig;
    /**
     * 
     * @type {RewardConfig}
     * @memberof Milestone
     */
    'friend_reward'?: RewardConfig;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof Milestone
     */
    'attributes'?: { [key: string]: string; };
    /**
     * 
     * @type {string}
     * @memberof Milestone
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof Milestone
     */
    'updated_at': string;
}
/**
 * User who shares his referral link for specific viral loop
 * @export
 * @interface Referral
 */
export interface Referral {
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'viral_loop_id': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'contact_id': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'channel_id': string;
    /**
     * 
     * @type {Array<CompletedMilestone>}
     * @memberof Referral
     */
    'completed_milestones'?: Array<CompletedMilestone>;
    /**
     * 
     * @type {Array<Friend>}
     * @memberof Referral
     */
    'created_friends'?: Array<Friend>;
    /**
     * 
     * @type {Array<Friend>}
     * @memberof Referral
     */
    'completed_friends'?: Array<Friend>;
    /**
     * 
     * @type {Array<Reward>}
     * @memberof Referral
     */
    'rewards'?: Array<Reward>;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'referral_link': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'updated_at': string;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof Referral
     */
    'attributes'?: { [key: string]: string; };
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'name': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'gateway_messenger_id': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'gateway_messenger_type': string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'email'?: string;
    /**
     * 
     * @type {string}
     * @memberof Referral
     */
    'messenger_id': string;
    /**
     * 
     * @type {boolean}
     * @memberof Referral
     */
    'force_new_link': boolean;
}
/**
 * Coupon created based on RewardConfig and Milestone
 * @export
 * @interface Reward
 */
export interface Reward {
    /**
     * 
     * @type {string}
     * @memberof Reward
     */
    'code': string;
    /**
     * 
     * @type {string}
     * @memberof Reward
     */
    'project_id': string;
    /**
     * 
     * @type {string}
     * @memberof Reward
     */
    'campaign_id': string;
    /**
     * 
     * @type {string}
     * @memberof Reward
     */
    'assigned_at': string;
}
/**
 * Reward configuration
 * @export
 * @interface RewardConfig
 */
export interface RewardConfig {
    /**
     * 
     * @type {string}
     * @memberof RewardConfig
     */
    'script_id'?: string;
    /**
     * 
     * @type {EmailNotification}
     * @memberof RewardConfig
     */
    'email_notification'?: EmailNotification;
}
/**
 * Viral Loop specifies start scripts for referral and friend and possible milestones
 * @export
 * @interface ViralLoop
 */
export interface ViralLoop {
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'type': ViralLoopTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'name': string;
    /**
     * 
     * @type {Array<Milestone>}
     * @memberof ViralLoop
     */
    'milestones'?: Array<Milestone>;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'forward_script_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'friend_script_id'?: string;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof ViralLoop
     */
    'attributes'?: { [key: string]: string; };
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'updated_at': string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'channel_id': string;
    /**
     * 
     * @type {EmailNotification}
     * @memberof ViralLoop
     */
    'referral_link_attributed_email_notification'?: EmailNotification;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'forward_link_hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'interaction_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'link_hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof ViralLoop
     */
    'referral_link_attributed_script_id'?: string;
}

export const ViralLoopTypeEnum = {
    EasyReferral: 'easy_referral',
    MilestoneReward: 'milestone_reward',
    EasyReferralNoWaba: 'easy_referral_no_waba'
} as const;

export type ViralLoopTypeEnum = typeof ViralLoopTypeEnum[keyof typeof ViralLoopTypeEnum];

/**
 * 
 * @export
 * @interface WebhookRequest
 */
export interface WebhookRequest {
    /**
     * 
     * @type {string}
     * @memberof WebhookRequest
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof WebhookRequest
     */
    'type': string;
}

/**
 * VloopApi - axios parameter creator
 * @export
 */
export const VloopApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Complete friend
         * @param {string} id 
         * @param {CompleteFriend} [completeFriend] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        completeFriend: async (id: string, completeFriend?: CompleteFriend, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('completeFriend', 'id', id)
            const localVarPath = `/viral-loops/{id}/friends/complete`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(completeFriend, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create friend
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Friend} [friend] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createFriend: async (orgId: string, id: string, channelId: string, friend?: Friend, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('createFriend', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('createFriend', 'id', id)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('createFriend', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}/friends`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(friend, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Milestone} [milestone] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createMilestone: async (orgId: string, id: string, channelId: string, milestone?: Milestone, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('createMilestone', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('createMilestone', 'id', id)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('createMilestone', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}/milestones`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(milestone, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create referral
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Referral} [referral] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createReferral: async (orgId: string, id: string, channelId: string, referral?: Referral, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('createReferral', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('createReferral', 'id', id)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('createReferral', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}/referrals`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(referral, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create Viral Loop
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {number} [limit] 
         * @param {ViralLoop} [viralLoop] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createViralLoop: async (organizationId?: string, channelId?: string, limit?: number, viralLoop?: ViralLoop, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/viral-loops`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)

            if (organizationId !== undefined) {
                localVarQueryParameter['organization_id'] = organizationId;
            }

            if (channelId !== undefined) {
                localVarQueryParameter['channel_id'] = channelId;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(viralLoop, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} mid 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteMilestone: async (orgId: string, id: string, mid: string, channelId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteMilestone', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteMilestone', 'id', id)
            // verify required parameter 'mid' is not null or undefined
            assertParamExists('deleteMilestone', 'mid', mid)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('deleteMilestone', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}/milestones/{mid}`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"mid"}}`, encodeURIComponent(String(mid)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Viral Loop
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteViralLoop: async (orgId: string, id: string, channelId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteViralLoop', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteViralLoop', 'id', id)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('deleteViralLoop', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Find Viral Loop by ID
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        findViralLoop: async (orgId: string, id: string, channelId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('findViralLoop', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('findViralLoop', 'id', id)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('findViralLoop', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List Viral Loops
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {number} [limit] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listViralLoops: async (organizationId?: string, channelId?: string, limit?: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/viral-loops`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)

            if (organizationId !== undefined) {
                localVarQueryParameter['organization_id'] = organizationId;
            }

            if (channelId !== undefined) {
                localVarQueryParameter['channel_id'] = channelId;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} mid 
         * @param {string} channelId 
         * @param {Milestone} [milestone] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMilestone: async (orgId: string, id: string, mid: string, channelId: string, milestone?: Milestone, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('updateMilestone', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('updateMilestone', 'id', id)
            // verify required parameter 'mid' is not null or undefined
            assertParamExists('updateMilestone', 'mid', mid)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('updateMilestone', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}/milestones/{mid}`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"mid"}}`, encodeURIComponent(String(mid)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(milestone, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Viral Loop
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {ViralLoop} [viralLoop] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateViralLoop: async (orgId: string, id: string, channelId: string, viralLoop?: ViralLoop, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('updateViralLoop', 'orgId', orgId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('updateViralLoop', 'id', id)
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('updateViralLoop', 'channelId', channelId)
            const localVarPath = `/viral-loops/{id}`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(viralLoop, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Webhook
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook: async (webhookRequest?: WebhookRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/webhook`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(webhookRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VloopApi - functional programming interface
 * @export
 */
export const VloopApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = VloopApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Complete friend
         * @param {string} id 
         * @param {CompleteFriend} [completeFriend] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async completeFriend(id: string, completeFriend?: CompleteFriend, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.completeFriend(id, completeFriend, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create friend
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Friend} [friend] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createFriend(orgId: string, id: string, channelId: string, friend?: Friend, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Friend>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createFriend(orgId, id, channelId, friend, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Milestone} [milestone] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createMilestone(orgId: string, id: string, channelId: string, milestone?: Milestone, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Milestone>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createMilestone(orgId, id, channelId, milestone, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create referral
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Referral} [referral] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createReferral(orgId: string, id: string, channelId: string, referral?: Referral, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Referral>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createReferral(orgId, id, channelId, referral, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create Viral Loop
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {number} [limit] 
         * @param {ViralLoop} [viralLoop] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createViralLoop(organizationId?: string, channelId?: string, limit?: number, viralLoop?: ViralLoop, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ViralLoop>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createViralLoop(organizationId, channelId, limit, viralLoop, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} mid 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteMilestone(orgId: string, id: string, mid: string, channelId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteMilestone(orgId, id, mid, channelId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Viral Loop
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteViralLoop(orgId: string, id: string, channelId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteViralLoop(orgId, id, channelId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Find Viral Loop by ID
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async findViralLoop(orgId: string, id: string, channelId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ViralLoop>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.findViralLoop(orgId, id, channelId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List Viral Loops
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {number} [limit] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listViralLoops(organizationId?: string, channelId?: string, limit?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ListViralLoops200Response>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listViralLoops(organizationId, channelId, limit, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} mid 
         * @param {string} channelId 
         * @param {Milestone} [milestone] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateMilestone(orgId: string, id: string, mid: string, channelId: string, milestone?: Milestone, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Milestone>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateMilestone(orgId, id, mid, channelId, milestone, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Viral Loop
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {ViralLoop} [viralLoop] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateViralLoop(orgId: string, id: string, channelId: string, viralLoop?: ViralLoop, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ViralLoop>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateViralLoop(orgId, id, channelId, viralLoop, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Webhook
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async webhook(webhookRequest?: WebhookRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.webhook(webhookRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * VloopApi - factory interface
 * @export
 */
export const VloopApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = VloopApiFp(configuration)
    return {
        /**
         * 
         * @summary Complete friend
         * @param {string} id 
         * @param {CompleteFriend} [completeFriend] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        completeFriend(id: string, completeFriend?: CompleteFriend, options?: any): AxiosPromise<void> {
            return localVarFp.completeFriend(id, completeFriend, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create friend
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Friend} [friend] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createFriend(orgId: string, id: string, channelId: string, friend?: Friend, options?: any): AxiosPromise<Friend> {
            return localVarFp.createFriend(orgId, id, channelId, friend, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Milestone} [milestone] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createMilestone(orgId: string, id: string, channelId: string, milestone?: Milestone, options?: any): AxiosPromise<Milestone> {
            return localVarFp.createMilestone(orgId, id, channelId, milestone, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create referral
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {Referral} [referral] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createReferral(orgId: string, id: string, channelId: string, referral?: Referral, options?: any): AxiosPromise<Referral> {
            return localVarFp.createReferral(orgId, id, channelId, referral, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create Viral Loop
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {number} [limit] 
         * @param {ViralLoop} [viralLoop] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createViralLoop(organizationId?: string, channelId?: string, limit?: number, viralLoop?: ViralLoop, options?: any): AxiosPromise<ViralLoop> {
            return localVarFp.createViralLoop(organizationId, channelId, limit, viralLoop, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} mid 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteMilestone(orgId: string, id: string, mid: string, channelId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteMilestone(orgId, id, mid, channelId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Viral Loop
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteViralLoop(orgId: string, id: string, channelId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteViralLoop(orgId, id, channelId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Find Viral Loop by ID
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        findViralLoop(orgId: string, id: string, channelId: string, options?: any): AxiosPromise<ViralLoop> {
            return localVarFp.findViralLoop(orgId, id, channelId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List Viral Loops
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {number} [limit] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listViralLoops(organizationId?: string, channelId?: string, limit?: number, options?: any): AxiosPromise<ListViralLoops200Response> {
            return localVarFp.listViralLoops(organizationId, channelId, limit, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update milestone
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} mid 
         * @param {string} channelId 
         * @param {Milestone} [milestone] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMilestone(orgId: string, id: string, mid: string, channelId: string, milestone?: Milestone, options?: any): AxiosPromise<Milestone> {
            return localVarFp.updateMilestone(orgId, id, mid, channelId, milestone, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Viral Loop
         * @param {string} orgId 
         * @param {string} id 
         * @param {string} channelId 
         * @param {ViralLoop} [viralLoop] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateViralLoop(orgId: string, id: string, channelId: string, viralLoop?: ViralLoop, options?: any): AxiosPromise<ViralLoop> {
            return localVarFp.updateViralLoop(orgId, id, channelId, viralLoop, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Webhook
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook(webhookRequest?: WebhookRequest, options?: any): AxiosPromise<void> {
            return localVarFp.webhook(webhookRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * VloopApi - object-oriented interface
 * @export
 * @class VloopApi
 * @extends {BaseAPI}
 */
export class VloopApi extends BaseAPI {
    /**
     * 
     * @summary Complete friend
     * @param {string} id 
     * @param {CompleteFriend} [completeFriend] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public completeFriend(id: string, completeFriend?: CompleteFriend, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).completeFriend(id, completeFriend, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create friend
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} channelId 
     * @param {Friend} [friend] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public createFriend(orgId: string, id: string, channelId: string, friend?: Friend, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).createFriend(orgId, id, channelId, friend, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create milestone
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} channelId 
     * @param {Milestone} [milestone] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public createMilestone(orgId: string, id: string, channelId: string, milestone?: Milestone, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).createMilestone(orgId, id, channelId, milestone, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create referral
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} channelId 
     * @param {Referral} [referral] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public createReferral(orgId: string, id: string, channelId: string, referral?: Referral, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).createReferral(orgId, id, channelId, referral, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create Viral Loop
     * @param {string} [organizationId] 
     * @param {string} [channelId] 
     * @param {number} [limit] 
     * @param {ViralLoop} [viralLoop] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public createViralLoop(organizationId?: string, channelId?: string, limit?: number, viralLoop?: ViralLoop, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).createViralLoop(organizationId, channelId, limit, viralLoop, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete milestone
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} mid 
     * @param {string} channelId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public deleteMilestone(orgId: string, id: string, mid: string, channelId: string, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).deleteMilestone(orgId, id, mid, channelId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Viral Loop
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} channelId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public deleteViralLoop(orgId: string, id: string, channelId: string, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).deleteViralLoop(orgId, id, channelId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Find Viral Loop by ID
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} channelId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public findViralLoop(orgId: string, id: string, channelId: string, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).findViralLoop(orgId, id, channelId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List Viral Loops
     * @param {string} [organizationId] 
     * @param {string} [channelId] 
     * @param {number} [limit] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public listViralLoops(organizationId?: string, channelId?: string, limit?: number, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).listViralLoops(organizationId, channelId, limit, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update milestone
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} mid 
     * @param {string} channelId 
     * @param {Milestone} [milestone] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public updateMilestone(orgId: string, id: string, mid: string, channelId: string, milestone?: Milestone, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).updateMilestone(orgId, id, mid, channelId, milestone, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Viral Loop
     * @param {string} orgId 
     * @param {string} id 
     * @param {string} channelId 
     * @param {ViralLoop} [viralLoop] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public updateViralLoop(orgId: string, id: string, channelId: string, viralLoop?: ViralLoop, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).updateViralLoop(orgId, id, channelId, viralLoop, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Webhook
     * @param {WebhookRequest} [webhookRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VloopApi
     */
    public webhook(webhookRequest?: WebhookRequest, options?: AxiosRequestConfig) {
        return VloopApiFp(this.configuration).webhook(webhookRequest, options).then((request) => request(this.axios, this.basePath));
    }
}



